#!perl

$prt = 1;
$to_file = 0;
$debug = "";

#if ($to_file) {
#	open OUT,">recomp.out";
#	select OUT;
#}

##########################################################################
#	recompounder_subs_lasse.pl
#	Skapar transkriptioner av en dekomponerad sammansttning (varu+bil) + delarnas transkriptioner.
#	Input r tv strngar
#	Exempel:   &top_lw(q/hund+koja/,q/'ho0nd--2'kO.ja/);
#	hund+koja	'ho0nd--2'kO.ja
#
#
#
#230201: CE & LW
###########################################################################


sub top_lw {
	my ($ort,$trk,@trks) = @_;

	if ($ort !~ /\+/) { return $trk; next; }	#added 9/3
		
	
	my ($fl_trk,$fl_ort,$ml);
	
$debug = "" if $prt;
	
	my @ort = split /\+/,$ort;
	my @trk = split /--/,$trk;

$debug = "ORTLED:  @ort\n" if $prt;

	
	my $el_trk = pop @trk;		#efterledet
	my @fl = @trk;		#fr- och mellanled		

$debug = "EFTERLED:  $el_trk\n" if $prt;
$debug = "FRLED:  @fl\n" if $prt;
	
	
	#***************************** FIXA FRLED OCH MELLANLED ***************************
$debug = "\nFIXA FR- OCH MELLANLED:\n\n" if $prt;
	my $antal = 0;						#skickas med fr att se om det r fl eller ml
	foreach $fl_trk (@fl) {					#frled + mellanled
		$fl_ort = $ort[$antal];				
		if ($antal == 0) {				#frled
			$fl_trk = &fl_tryck($fl_trk);		#betoning
		} else {					#mellanled
			$fl_trk = &ml_tryck($fl_trk);		#betoning
			$fl_trk = change_e($fl_trk,$fl_ort);	#changed 1/3
			}
		push @trks,$fl_trk;
		$antal++;	
		}
	#***************************** FIXA EFTERLED ****************************************
$debug = "\nFIXA EFTERLED:\n\n" if $prt;
	
	$el_trk = &prepare_el($el_trk);		#gr iordning efterledet
	push @trks,$el_trk;


	my $trks = join "\-",@trks;

		
	$trks = &phonology($trks);
	$trks = &special_trks($trks);		#new 13/2
	#print OUT "$lemma_ort\t$lemma_trk\n";
	#print OUT "$codes\t$orts\t$trks\n";

	return $trks;
}

















#******************************** SPECIAL TRKS ***********************************
sub special_trks {						#added 13/2
	my $trks = shift;

$debug = "ENTERING SUB special_trks\($trks\)\n" if $prt;

	$trks =~ s/^2\'([a-z A-Z 02\'\~6:\+]*)\.\'2(bE:r)/\'$1\.$2/;		#tvstaviga p -br
	
	#2'.*\.rveri/plgeri/fylleri
	#if ($trks =~ s/2\'([a-z A-Z 0 6 ~ \+ :]*\.)(re:\+\.Ve|fY.le|plo:\.ge)(\.\'2ri:)/$1$2\.\'ri:/)
	#{ print  "$trks\n"; }

$debug = "LEAVING SUB special_trks\($trks\)\n\n" if $prt;

	return $trks;

} #end sub
#******************************** FONOLOGISKA PROCESSER ***********************************
sub phonology {
	my $sms_trk = shift;

$debug = "ENTERING SUB phonology\($sms_trk\)\n" if $prt;

	my ($i,$j,$fl,$el);
	@sms_trk = split /-/,$sms_trk;

$i = 0;
$j = 1;

for ($i = 0; $i < $#sms_trk; $i++) {
	$j = $i + 1;
	($fl,$el) = &dk_fl_stoed($sms_trk[$i],$sms_trk[$j]);	#ta bort avslutande std fre smsgrns
	($fl,$el) = &velarisering($fl,$el);			#velarising
	$fl = &devoice($fl);					#devoicing
	$fl = &special_lmcc($fl);				#special
	$sms_trk[$i] = $fl; $sms_trk[$j] = $el;
	}

$sms_trk = join "\.",@sms_trk;

$debug = "LEAVING SUB phonology\($sms_trk\)\n\n" if $prt;

return $sms_trk;
		} #end sub
	

#******************************************** EFTERLED *********************************************
sub prepare_el {
	my $el_trk = shift;
$debug = "ENTERING SUB prepare_el\($el_trk\)\n" if $prt;
	$el_trk = &el_tryck ($el_trk,$ort);						#betoning
$debug = "LEAVING SUB prepare_el\($el_trk\)\n\n" if $prt;
	return $el_trk;	
	}
		
#************************************** BETONING *****************************************************		

sub fl_tryck {
	my $fl = shift;
$debug = "ENTERING SUB fl_tryck\($fl\)\n" if $prt;
	$fl =~ s/$bibet//g;
#print "  Danish does not do anything here\n" if $prt;
$debug = "LEAVING SUB fl_tryck\($fl\)\n\n" if $prt;
	return $fl;
} # end sub


sub sw_fl_tryck {
	# ndrar huvudtryck till tonem 2
	# och tar bort bitryck frn frledet
	my $fl = shift;
$debug = "ENTERING SUB fl_tryck\($fl\)\n" if $prt;
		
#changed 27/2		
	$fl =~ s/$grav/<TRYCK>/;
$debug = "  FL1: $fl\n" if $prt;
	$fl =~ s/$akut([^2])/<TRYCK>$1/;
$debug = "  FL2: $fl\n" if $prt;
	$fl =~ s/$bibet//g;
$debug = "  FL3: $fl\n" if $prt;
	$fl =~ s/<TRYCK>/$grav/;
$debug = "  FL4: $fl\n" if $prt;
$debug = "LEAVING SUB fl_tryck\($fl\)\n\n" if $prt;
	return $fl;
} # end sub

sub ml_tryck {			#ta bort all betoning frn mellanleden
	my ($ml,$ort) = @_;
$debug = "ENTERING SUB ml_tryck\($ml\,$ort\)\n" if $prt;
	$ml =~ s/[$grav]//g;		#changed 27/2
$debug = "LEAVING SUB ml_tryck\($ml\)\n\n" if $prt;
	return $ml;
	} #end sub

sub el_tryck {
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB el_tryck\($el\,$el_ort\)\n" if $prt;

	if ( $el =~ /$second/) {			#om det brjar p betonbart prefix + stavelsegrns:
		$el = &stress_second($el,$el_ort);
	} elsif ($el =~ /$akut.*$bibet/) {			#$el har bde huvud- och bitryck utsatt
		$el = &stress_remove_main($el,$el_ort);	
	} elsif ($el !~ /($grav|$bibet)/) { 				#$el har bara akut betoning
		if ($el =~ /$suffix$/) {			#om det slutar p betonbart suffix (-het)
			$el = &stress_suffix($el,$el_ort);
		} else { 
		$el = &stress_main($el,$el_ort);
		}
	} elsif ($el =~ /$grav/ && $el !~ /$bibet/) {		#$el har grav betoning, bitryck r ej utsatt	
		if ( $el =~ /^($prefix)\./ && $el !~ /$endings$/) {	#om det brjar p betonbart prefix + stavelsegrns:
			$el = &stress_right($el,$el_ort);
		} elsif ($el =~ /$suffix$/) {			#om det slutar p betonbart suffix (-het)
			$el = &stress_suffix($el,$el_ort);
		} elsif ($el =~ /$special_word$/) {		#speciella ord, bitryck p andra stavelsen
			$el = &stress_second($el,$el_ort);
		} elsif ($el =~ /$word_last$/) {
			$el = &stress_last($el,$el_ort);	
		} else {
			$el = &stress_main($el,$el_ort);
		}
	}

	$el =~ s/<BITRYCK>/$bibet/;
$debug = "LEAVING SUB el_tryck\($el\)\n\n" if $prt;
	return $el;
} #end sub

#changed 2/3
sub sw_el_tryck {
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB el_tryck\($el\,$el_ort\)\n" if $prt;

	if ( $el =~ /$second/) {			#om det brjar p betonbart prefix + stavelsegrns:
		$el = &stress_second($el,$el_ort);
	} elsif ($el =~ /$grav.*$bibet/) {			#$el har bde huvud- och bitryck utsatt
		$el = &stress_remove_main($el,$el_ort);	
	} elsif ($el !~ /($grav|$bibet)/) { 				#$el har bara akut betoning
		if ($el =~ /$suffix$/) {			#om det slutar p betonbart suffix (-het)
			$el = &stress_suffix($el,$el_ort);
		} else { 
		$el = &stress_main($el,$el_ort);
		}
	} elsif ($el =~ /$grav/ && $el !~ /$bibet/) {		#$el har grav betoning, bitryck r ej utsatt	
		if ( $el =~ /^($prefix)\./ && $el !~ /$endings$/) {	#om det brjar p betonbart prefix + stavelsegrns:
			$el = &stress_right($el,$el_ort);
		} elsif ($el =~ /$suffix$/) {			#om det slutar p betonbart suffix (-het)
			$el = &stress_suffix($el,$el_ort);
		} elsif ($el =~ /$special_word$/) {		#speciella ord, bitryck p andra stavelsen
			$el = &stress_second($el,$el_ort);
		} elsif ($el =~ /$word_last$/) {
			$el = &stress_last($el,$el_ort);	
		} else {
			$el = &stress_main($el,$el_ort);
		}
	}

	$el =~ s/<BITRYCK>/$bibet/;
$debug = "LEAVING SUB el_tryck\($el\)\n\n" if $prt;
	return $el;
} #end sub


#**********************************************************************************************************
#subbar som flyttar efterledens betoning

#flyttar bitrycket till det betonbara suffixet
sub stress_suffix {
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB stress_suffix\($el\,$el_ort\)\n" if $prt;
	$el =~ s/[$bibet]//g;
	$el =~ s/(.*)\.($suffix)$/$1\.<BITRYCK>$2/;
	$el = &change_e($el,$el_ort);
$debug = "LEAVING SUB stress_suffix\($el\)\n\n" if $prt;
	return $el;
	}

#flyttar bitrycket en stavelse till hger om huvudtrycket
sub stress_right {
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB stress_right\($el\,$el_ort\)\n" if $prt;
	$el =~ s/$bibet//;
	$el =~ s/^2\'([$tkn]*)\.(.*)/$1\.<BITRYCK>$2/;	#changed 13/2
	$el =~ s/$grav//;
	$el = &change_e($el,$el_ort);
$debug = "LEAVING SUB stress_right\($el\)\n\n" if $prt;
	return $el;
	}

#flyttar bitrycket till sista stavelsen
sub stress_last {		
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB stress_last\($el\,$el_ort\)\n" if $prt;
	$el =~ s/$grav//g;
	$el =~ s/(.*)\.(.*)/$1\.<BITRYCK>$2/;
	$el = &change_e($el,$el_ort);
$debug = "LEAVING SUB stress_last\($el\)\n\n" if $prt;
	return $el;
	}

#flyttar bitrycket till andra stavelsen i ordet
sub stress_second {
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB stress_second\($el\,$el_ort\)\n" if $prt;
	$el =~ s/[$bibet]//g;	
	$el =~ s/([$tkn])\.(.*)/$1\.<BITRYCK>$2/;
	$el = &change_e($el,$el_ort);
$debug = "LEAVING SUB stress_second\($el\)\n\n" if $prt;
	return $el;
	}

#gr huvudtryck till bitryck
sub stress_main {
	my $el = shift;
$debug = "ENTERING SUB stress_main\($el\)\n" if $prt;
	$el =~ s/($grav|$akut)/<BITRYCK>/;
$debug = "LEAVING SUB stress_main\($el\)\n\n" if $prt;
	return $el;
	}					

#tar bort huvudtrycket, bitrycket behlls
sub stress_remove_main {
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB stress_remove_main\($el\,$el_ort\)\n" if $prt;
	$el =~ s/$akut//;
	$el = &change_e($el,$el_ort);
$debug = "LEAVING SUB stress_remove_main\($el\)\n\n" if $prt;
	return $el;
	}

sub sw_stress_remove_main {
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB stress_remove_main\($el\,$el_ort\)\n" if $prt;
	$el =~ s/$grav//;
	$el = &change_e($el,$el_ort);
$debug = "LEAVING SUB stress_remove_main\($el\)\n\n" if $prt;
	return $el;
	}

#sista ledet har akut betoning
sub stress_toneme1 {
	my $el = shift;
$debug = "ENTERING SUB stress_toneme1\($el\)\n" if $prt;
	$el =~ s/$grav/\'/;
$debug = "LEAVING SUB stress_toneme1\($el\)\n\n" if $prt;
	return $el;
	}

#changed 27/2
#ndrar E till e om  inte finns i ortografin och om huvudtrycket frsvinner sedan
sub change_e {				#changed 14/2
	my ($el,$el_ort) = @_;
$debug = "ENTERING SUB change_e\($el\,$el_ort\)\n" if $prt;
	if ($el_ort !~ /(r|(s|t|d|n|l)\+)/ && $el =~ /(^|$del)[$tkn_no_stress]*E(r|(s|t|d|n|l)\+)/) {
		$el =~ s/^(.*$del?[^$bibet][$tkn_no_stress]*)E([r(s|t|d|n|l)\+].*)/$1e$2/;
		}
$debug = "LEAVING SUB change_e\($el\)\n\n" if $prt;
	return $el;
	}


#********************* TA BORT AVSLUTANDE STD FRE SMS-GRNS FR DANSKA **********************

sub dk_fl_stoed {
	my ($fl,$el) = @_;
		$fl =~ s/($vowel)\?$/$1/;
	return ($fl,$el);
} # end sub



#********************* RETROFLEXERING AV FRLED OCH MELLANLED **********************
sub fl_retroflex {
	my $fl = shift;
$debug = "ENTERING SUB fl_retroflex\($fl\)\n" if $prt;
	$fl =~ s/(s|t|d|l|n)(\+)(s|t|d|l|n)$/$1$2$3\+/; 
	$fl =~ s/r(s|t|d|l|n)$/$1\+/;
$debug = "LEAVING SUB fl_retroflex\($fl\)\n\n" if $prt;
	return ($fl);
	}

#**************************************************************************************************
sub fl_special {
	my $fl = shift;
$debug = "ENTERING SUB fl_special\($fl\)\n" if $prt;
	$fl =~ s/2\'ri:ks/2\'rIks/;
	$fl =~ s/2\'dA:gs/2\'daks/;
	$fl =~ s/(stA:ds|stA:ts)/stats/;
	$fl =~ s/sku:gs/skUks/;
	$fl =~ s/kri:gs/krIks/;
	$fl =~ s/stri:ds/strIts/;
	$fl =~ s/li:Vs/lIfs/;
	$fl =~ s/de\+:ds/de+ts/;
	$fl =~ s/ri:ks/rIks/;
	
	$fl =~ s/2\'al\.kU\.ho:l/al\.kU\.2\'ho:l/;
	$fl =~ s/fe\+\.ru0:t/2\'fe\+:\.ru0:t/;
$debug = "LEAVING SUB fl_special\($fl\)\n\n" if $prt;
	return $fl;
	}

sub el_special {
	my $el = shift;
	return $el;
	}

#************************** DEVOICE ********************************************
#changed 27/2
sub devoice {
	my $fl = shift;
$debug = "ENTERING SUB devoice\($fl\)\n" if $prt;
	$fl =~ s/($shortvowel)(b|d|g|V|v)(s|t)/$1$devoice{$3}$4/;
$debug = "LEAVING SUB devoice\($fl\)\n\n" if $prt;
	return $fl;
} #end sub

#************************** SPECIAL LMCCs ********************************************
#changed 27/2
sub special_lmcc {
	my $fl = shift;
$debug = "ENTERING SUB special_lmcc\($fl\)\n" if $prt;

if (exists ($special_lmcc{$fl})) {
	$fl =~ s/$fl/$special_lmcc{$fl}/;
	}
$debug = "LEAVING SUB special_lmcc\($fl\)\n\n" if $prt;
	
	return $fl;
} #end sub

#*************************************** RETROFLEXERING ****************************************************
sub retr {
	my ($fl,$el) = @_;
$debug = "ENTERING SUB retr\($fl\,$el\)\n" if $prt;
	my ($new_fl,$new_el_start,$new_el_rest);
	my $cmptemp = $fl."<SKARV>".$el;
	if ($cmptemp =~ /^(.*)r<SKARV>([\'\"\.2]*[sndtl])([^\+].*)$/) {
		$new_fl = $1;
		$new_el_start = $2;
		$new_el_rest = $3;
		unless (&no_retr_flag($fl,$el)) {
			$fl =~ s/r$//;
			$el =~ s/^([^sndtl]*?[sndtl])/$1\+/;
			} else {
			$el =~ s/^([^sndtl]*?[ndtl])/$1\+/;
			}

	} # end if


	
	($fl,$el) = &retr_trans($fl,$el);
$debug = "LEAVING SUB retr\($fl\,$el\)\n\n" if $prt;
	return ($fl,$el);
} # end sub

sub no_retr_flag {
	my ($fl,$el) = @_;
$debug = "ENTERING SUB no_retr_flag\($fl\,$el\)\n" if $prt;
	my $cmptemp = $fl."<SKARV>".$el;
	my $last_fl_syll = (split /\./,$fl)[-1];
	my $stress_on_last_syll = $last_fl_syll =~ s/\'/\'/g;
	my $r_after_short_vowel = $last_fl_syll =~ s/([^\:])r$/\$1r/g;
	my $no_retr_flag = 0;
	$no_retr_flag = 1 if ($stress_on_last_syll && $r_after_short_vowel);
	#print OUT "STRESS ON LAST SYLL: $stress_on_last_syll\n";
	#print OUT "R AFTER SHORT VOWEL: $r_after_short_vowel\n";
	#print OUT "NO RETURN FLAG IS:   $no_retr_flag\n";
#	print "$last_fl_syll\n$stress_on_last_syll\n$r_after_short_vowel\n$no_retr_flag\n\n";
$debug = "LEAVING SUB no_retr_flag\($no_retr_flag\)\n\n" if $prt;
	return $no_retr_flag;
}

sub retr_trans {
	my ($fl,$el) = @_;
$debug = "ENTERING SUB retr_trans\($fl\,$el\)\n" if $prt;
	if ($fl =~ /[sndtl]\+$/) {
		if ($el =~ /^[\'\"\.2]*[sndtl][^\+]/) {
			$el =~ s/^([\'\"\.2]*[sndtl])([^\+])/$1\+$2/;
		}
	}
	if ($el =~ /^[\'\"\.2]*[sndtl][\+][sndtl][^\+]/) {
		$el =~ s/^([\'\"\.2]*[sndtl][\+][sndtl])([^\+])/$1\+$2/;
	}
	if ($el =~ /^[\'\"\.2]*[sndtl][\+][sndtl][^\+]/) {
		$el =~ s/^([\'\"\.2]*[sndtl][\+][sndtl])([^\+])/$1\+$2/;
	}
	if ($el =~ /^[\'\"\.2]*[sndtl][\+][sndtl][^\+]/) {
		$el =~ s/^([\'\"\.2]*[sndtl][\+][sndtl])([^\+])/$1\+$2/;
	}
$debug = "LEAVING SUB retr_trans\($fl\,$el\)\n\n" if $prt;
	return ($fl,$el);
} # end sub

#****************************************** VELARISERING ********************************************
sub velarisering {
	my ($fl,$el) = @_;
$debug = "ENTERING SUB velarisering\($fl\,$el\)\n" if $prt;
$debug = "  Doesn't do anything for danish" if $prt;
$debug = "LEAVING SUB velarisering\($fl\,$el\)\n\n" if $prt;
	return ($fl,$el);
} # end sub

sub sw_velarisering {
	my ($fl,$el) = @_;
$debug = "ENTERING SUB velarisering\($fl\,$el\)\n" if $prt;
	my $cmptemp = $fl."<SKARV>".$el;
	$cmptemp =~ s/([^m])n(<SKARV>[\'\"\.2]*[gk])/$1nK$2/;
	($fl,$el) = split "<SKARV>",$cmptemp;
$debug = "LEAVING SUB velarisering\($fl\,$el\)\n\n" if $prt;
	return ($fl,$el);
} # end sub

#********************************** SYLLABIFY *****************************************



sub retroflex_transform {
	my $xstring = shift;
$debug = "ENTERING SUB retroflex_transform\($xstring\)\n" if $prt;
	my $n;
	#print STDOUT "$xstring\n";
	
	if ($xstring =~ /^(.*)(x010|x020|x030|x040|x050|x060|x070|x080|x090)r((x500|x510|x520|x530)*)(x280|x310|x340|x390)(.*)$/) {
		if ($5 eq "x280") {$n = "x100"}
		elsif ($5 eq "x310") {$n = "x110"}
		elsif ($5 eq "x340") {$n = "x120"}
		elsif ($5 eq "x390") {$n = "x130"}
		$xstring = $1.$2.$3.$n.$6;
	}

	foreach (0..4) {
	if ($xstring =~ m/^(.*)(x100|x110|x120|x130)((x500|x510|x520|x530)*)(x280|x310|x340|x390)(.*)$/) {
		if ($5 eq "x280") {$n = "x100"}
		elsif ($5 eq "x310") {$n = "x110"}
		elsif ($5 eq "x340") {$n = "x120"}
		elsif ($5 eq "x390") {$n = "x130"}
		$xstring = $1.$2.$3.$n.$6;
	}
	}
	
	my $ret = $xstring;
$debug = "LEAVING SUB retroflex_transform\($ret\)\n\n" if $prt;
	return $ret
	
} #end sub




1;

__END__


SUBS

special_trks
phonology
prepare_el
fl_tryck
ml_tryck
el_tryck
stress_suffix
stress_right
stress_last
stress_second
stress_main
stress_remove_main
stress_toneme1
change_e
fl_retroflex
fl_special
devoice
special_lmcc
retr
no_retr_flag
retr_trans
velarisering
lasse_syllabify	(not in use)
x_ify_lh	(not in use)
syllabify	(not in use)
retroflex_transform
fix_corrupt_syll	(not in use)


CONSTANTS

2	stress_pattern
11	el_trk
11	bibet
3	syllabified
2	satsaccent
3	touched
2	prefix
2	word_last
1	winlog
3	trk
75	fl
2	e_long
5	newret
62	prt
2	rd
2	i_long
2	map
2	rl
1	lemma_ort
2	rn
9	fl_trk
14	trks
2	u_long
2	rs
2	rt
2	new_el_start
4	last_fl_syll
2	endings
2	y_long
5	outel
3	tkn_no_stress
3	tkn
2	deletetag
8	xstring
1	untouched
4	indexstring
2	worddel
2	oe
2	x_h6
6	cmptemp
3	newtrk
7	wd
4	r_after_short_vowel
1	devoice
3	syll_pattern
4	convertedstring
2	to_file
2	oe_long
10	sms_trk
4	voc_pattern
29	el_ort
2	u0
2	lhs
3	listel
1	codes
6	no_retr_flag
4	suffix
4	del
7	ort
4	stress_on_last_syll
2	new_fl
54	ttt
1	lemma_trk
2	shortvowel
2	o_long
2	special_lmcc
4	a
2	b
2	d
4	e
3	onset_pattern
2	f
3	fl_ort
2	g
2	h
1	orts
8	i
7	j
17	ret
2	k
4	ilstring
2	l
2	m
2	prelhs
13	n
2	outstring
2	p
13	grav
4	antal
131	el
2	r
7	s
2	u0_long
3	t
4	akut
2	v
2	new_el_rest
2	index
6	ml
2	second
2	special_word



BORTTAGET

%map = qw(010 A: 020 e: 030 i: 040 u: 050 u0: 060 y: 070 o: 080 E: 090 e+: 100 d+ 110 t+ 120 s+ 130 n+ 140 l+ 150 e&U 160 a&U 170 -WARNING- 180 a 190 e 200 I 210 U 220 o0 230 Y 240 O 250 E 260 e+ 270 b 280 d 290 g 300 p 310 t 320 k 330 f 340 s 350 h6~ 360 V 370 C 380 m 390 n 400 nK 410 l 420 r 430 h 440 j 500 ' 510 2' 520 '2 530 . 540 " 550 _);

$eU = "e\\&U";
$aU = "a\\&U";
$u0_long = "u0:";
$oe_long = "e\\+:";
$x_h6 = "h6~";
$A_long = "A:";
$e_long = "e:";
$i_long = "i:";
$u_long = "u:";
$y_long = "y:";
$o_long = "o:";	
$E_long = "E:";
$rt = "t\\+";
$rd = "d\\+";
$rs = "s\\+";
$rn = "n\\+";
$rl = "l\\+";
$u0 = "o0";
$oe = "e\\+";
$N = "nK";
$a = "a";
$e = "e";
$I = "I";
$U = "U";
$Y = "Y";
$O = "O";
$E = "E";
$b = "b";
$d = "d";
$g = "g";
$p = "p";
$t = "t";
$k = "k";
$f = "f";
$s = "s";
$v = "V";
$C = "C";
$m = "m";
$n = "n";
$l = "l";
$r = "r";
$h = "h";
$j = "j";

sub lasse_syllabify {
	my ($listel,$outel,$ret,$indexstring,$untouched,$touched);
	my $wd = shift;
print "ENTERING SUB lasse_syllabify\($wd\)\n" if $prt;
	
	my $index = q/|||||\#|/;
	# temporarily remove indexes
	if ($wd =~ /^(.+?)(($index)*)$/) {
		$indexstring = $2;
		$wd = $1;
	}
	else {$indexstring = "";}
		
	# get the part to syllabify
	my @sylls = split /\./,$wd;
	
		$touched = $wd;
			
	my $prelhs = &x_ify_lh($touched);
	my $lhs = $prelhs;
	my @lhs_list = split /x530/,$lhs;
	my @syllabified = ();
	foreach $listel (@lhs_list) {
		push @syllabified,&syllabify($listel);
	} # end foreach

	my $syllabified = join "x530",@syllabified;
	$syllabified =~ s/^x//;
	my @out = split /x/,$syllabified;
	my $convertedstring = "";
	
	foreach $outel (@out) {
		if (exists $map{$outel}) {$convertedstring .= $map{$outel};}
		else {	
			print "SYMBOL ERROR $outel in $wd\n";
print "LEAVING SUB lasse_syllabify\($ret\)\n\n" if $prt;
			return $ret
		} # end else
	}
	
	# Ugly fix to avoid syllabification in word boundaries
	$convertedstring =~ s/([\_\"]+)\./$1/g;
	my $outstring = "$convertedstring";
	$newtrk = $outstring.$indexstring;
print "LEAVING SUB lasse_syllabify\($newtrk\)\n\n" if $prt;
	return $newtrk;

} # end sub



sub x_ify_lh {
	my $ttt = shift;
print "ENTERING SUB x_ify_lh\($ttt\)\n" if $prt;

		#changed 27/2
	$ttt =~ s/$eU/x150/g;
	$ttt =~ s/$aU/x160/g;
	$ttt =~ s/$u0_long/x050/g;
	$ttt =~ s/$oe_long/x090/g;
	$ttt =~ s/$x_h6/x350/g;
	$ttt =~ s/$A_long/x010/g;
	$ttt =~ s/$e_long/x020/g;
	$ttt =~ s/$i_long/x030/g;
	$ttt =~ s/$u_long/x040/g;
	$ttt =~ s/$y_long/x060/g;
	$ttt =~ s/$o_long/x070/g;
	$ttt =~ s/$E_long/x080/g;
	$ttt =~ s/$rd/x100/g;
	$ttt =~ s/$rt/x110/g;
	$ttt =~ s/$rs/x120/g;
	$ttt =~ s/$rn/x130/g;
	$ttt =~ s/$rl/x140/g;
	$ttt =~ s/$u0/x220/g;
	$ttt =~ s/$oe/x260/g;
	$ttt =~ s/$N/x400/g;
	$ttt =~ s/$grav/x510/g;
	$ttt =~ s/$bibet/x520/g;
	$ttt =~ s/$a/x180/g;
	$ttt =~ s/$e/x190/g;
	$ttt =~ s/$I/x200/g;
	$ttt =~ s/$U/x210/g;
	$ttt =~ s/$Y/x230/g;
	$ttt =~ s/$O/x240/g;
	$ttt =~ s/$E/x250/g;
	$ttt =~ s/$b/x270/g;
	$ttt =~ s/$d/x280/g;
	$ttt =~ s/$g/x290/g;
	$ttt =~ s/$p/x300/g;
	$ttt =~ s/$t/x310/g;
	$ttt =~ s/$k/x320/g;
	$ttt =~ s/$f/x330/g;
	$ttt =~ s/$s/x340/g;
	$ttt =~ s/$v/x360/g;
	$ttt =~ s/$C/x370/g;
	$ttt =~ s/$m/x380/g;
	$ttt =~ s/$n/x390/g;
	$ttt =~ s/$l/x410/g;
	$ttt =~ s/$r/x420/g;
	$ttt =~ s/$h/x430/g;
	$ttt =~ s/$j/x440/g;
	$ttt =~ s/$akut/x500/g;
	$ttt =~ s/$del/x530/g;
	$ttt =~ s/$satsaccent/x540/g;
	$ttt =~ s/$worddel/x550/g;

	#$t->insert("end","xify returns:   $ttt\n") if $winlog;
print "LEAVING SUB x_ify_lh\($ttt\)\n\n" if $prt;
	
	return $ttt;

} # end sub



sub syllabify {
	my $ilstring = shift;
print "ENTERING SUB syllabify\($ilstring\)\n" if $prt;
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x080|x090|x150|x160|x170|x180|x190|x200|x210|x220|x230|x240|x250|x260)";
	my $stress_pattern = "(x500|x510|x520|)";
	my $syll_pattern = "x530";

	my $onset_pattern = join "|",@il_onsets;
	$onset_pattern =~ s/^(.*)$/\($1|\)/;

	my $ret = "";

	while ($ilstring =~ s/^((.*?)($stress_pattern)($onset_pattern)($voc_pattern))//) {
		$ret .= "$2$syll_pattern$3$5$7";
	}

	$ret .= $ilstring;
	$ret =~ s/^$syll_pattern//;
	
	# ugly fix to avoid syllabifying after a word boundary
	$ret = fix_corrupt_syll($ret);
print "LEAVING SUB syllabify\($ret\)\n\n" if $prt;
	return $ret;
	
} # end sub

# Fix that takes care of unusual initial clusters such as ts, ps and so on that are not legal onsets but exists
# appends syllables with no vowel with the syllable that follows 
sub fix_corrupt_syll {
	my $ret = shift;
print "ENTERING SUB fix_corrupt_syll\($ret\)\n" if $prt;
	my $newret = "";
	my @newsylls = ();
	my $deletetag = "TABORT";
	my @sylls = split /x530/,$ret;
	my $voc_pattern = "(x010|x020|x030|x040|x050|x060|x070|x080|x090|x150|x160|x170|x180|x190|x200|x210|x220|x230|x240|x250|x260)";

	foreach $s (@sylls) {
		unless ($s =~ /$voc_pattern/) {
			$s = $s.$deletetag;
		} # end unless
		push @newsylls,$s;
	}
	$newret = join "x530",@newsylls;
	$newret =~ s/TABORTx530//g;
print "LEAVING SUB fix_corrupt_syll\($newret\)\n\n" if $prt;
	return $newret;
} # end sub


