#!perl

$thisFile = "CorrPhon.translate.pl";

if ($#ARGV != 1) {die "Please specify the ini-file and the name of the output shell!\n";}
($ini, $shell) = @ARGV;


# open the output shell file
open (SHELL, ">$shell") or die "Can't open $shell for writing: $!\n";
#print SHELL "#!perl -w\n";
print SHELL "## ---------------------------------------------------------------------------\n";
print SHELL "## $shell\n";
print SHELL "## Created using $thisFile at ",scalar(localtime),"\n";
print SHELL "## ---------------------------------------------------------------------------\n";


# open the ini-file
open (INI, $ini) or die "Can't open $ini for read: $!\n";
print STDOUT "Reading values from $ini...\n";
print SHELL "## Values from $ini:\n";
while (<INI>) {
	chomp;
	$line = $_;
	if ($line !~ /^$/ && $line !~ /^\#/) {
		my ($name, $value) = split(/\t+=\t/, $line);
		if ($name =~ /^(infile|outfile|rulefile|corrPhon)$/) {
			$value =~ s/\\/\//g;		# replace \ with /
			$value =~ s/\/\//\//g;		# replace // with /
#			$value =~ s/ /\\ /g;		# replace space with \space
			$string = "\$$name = \"$value\"\;";
			eval $string;
		}
		elsif ($line =~ /^trc\_index/) {
			$value = "($value)";
			$string = "\@$name = $value\;";
			if ($value !~ /^\([0-9]+(,(\s)?[0-9]+)*\)$/) {
				die "ERROR: trc_index has an invalid value.\nIt should be a comma-separated list with one or more number elements \nPlease correct that and run $thisFile again.\n";
			}		
			else {eval $string;}
		}
		elsif ($line =~ /^trc\_(style|lang)\_index/) {
			if ($line =~ /N\/A/) {
				$value = "()";
			}
			else {
				$plus = $value;
				$plus =~ s/^[^\+]*\+(.+)$/$1/;
				$value = "(";
				foreach $trcInd (@trc_index) {
					$myIndex = $trcInd+$plus;
					$value = $value.$myIndex.", ";
				}
				$value =~ s/, $/\)/;
			}
			$name = $name."_original";	
			$string = "\@$name = $value\;";
		}
		elsif ($line =~ /^morph\_index/) {
			$string = "\$$name = $value\;";
			if ($value !~ /^[0-9]+$/ || $value =~ /^0[0-9]+$/) {
				die "ERROR: morph_index has an invalid value.\nIt should be a single number.\nPlease correct that and run $thisFile again.\n";
			}
		}
		elsif ($line =~ /^(w|e)\_/) {
			$value =~ s/yes/1/;
			$value =~ s/no/0/;
			$name =~ s/e\_illegal\_position\_for\_syll\_delim/e01/;
			$name =~ s/e\_non\_consistent\_number\_of\_word\_bound/e02/;
			$name =~ s/e\_illegal\_symbol/e03/;
			$name =~ s/e\_no\_nucleus/e04/;
			$name =~ s/e\_too\_many\_nuclei/e05/;
			$name =~ s/e\_illegal\_stress\_pattern/e06/;
			$name =~ s/e\_onset\_not\_initially/e07/;
			$name =~ s/e\_illegal\_onset/e08/;
			$name =~ s/e\_illegal\_coda/e09/;
			$name =~ s/e\_mop\_violation/e10/;
			$name =~ s/w\_unwanted\_duplication/w01/;
			$name =~ s/w\_non\_comp\_with\_sec\_stress/w02/;
			$name =~ s/w\_rare\_onset/w03/;
			$name =~ s/w\_rare\_coda/w04/;
			$name =~ s/w\_mop\_violation/w05/;
			$name =~ s/w\_geminate\_consonant/w06/;
			if ($line =~ /^e/) {$string = "\$ERROR_MSGS{\'$name\'} = $value;";}
			else {$string = "\$WARN_MSGS{\'$name\'} = $value;";}
		}
		else {
			$value =~ s/,\s/\|/g;				# replace ',' (comma) with vertical bar
			$value =~ s/N\/A/\-1/;				# replace N/A with -1
			$value =~ s/^yes$/1/;
			$value =~ s/^no$/0/;
			$value =~ s/none/\.*/;				# replace none with .*
			if ($value !~ /^(\-)?[0-9]+$/) {
				$value = "\'".$value."\'";
			}
			$string = "\$$name = $value\;";
			eval $string;
		}
		print SHELL "$string\n";
	}
}
print SHELL "## END: Values from $ini\n";
print SHELL "## ---------------------------------------------------------------------------\n";
close (INI);


open (TRC_ALPHA, "$trc_alphabet");
print STDOUT "Reading values from $trc_alphabet...\n";
print SHELL "## Values from $trc_alphabet:\n";
while (<TRC_ALPHA>) {
	chomp;
	$line = $_;
	if ($line !~ /^$/ && $line !~ /^\#/) {
		my ($name, $value) = split(/\t+=\t/, $line);
		if ($line !~ /^pattern/) {
			$value =~ s/,\s/\|/g;				# replace ',' (comma) with vertical bar
			$value =~ s/([\}\@\*\'\%\"\+\$\_\\])/\\$1/g;	# precede spec chars with backslash
			$value = "\'".$value."\'";
		}
		my $string = "\$$name = $value\;";
		print SHELL "$string\n";
	}
}
print SHELL "## END: Values from $trc_alphabet\n";
print SHELL "## ---------------------------------------------------------------------------\n";
close (TRC_ALPHA);


open (RULES, "$rulefile");
print STDOUT "Reading values from $rulefile...\n";
print SHELL "## Values from $rulefile:\n";
$CODA_legal_str = "";
$DERIV_str = "";
while (<RULES>) {
	chomp;
	$line = $_;
	
	if ($line =~ /^ALLOWED_DUPL/) {
		my ($name, $value) = split(/\t+=\t/, $line);
		$value =~ s/\|/.\'\|\'./g;			# replace | with .'|'.
		$value =~ s/(\")/\\$1/g;
		$value = "'".$value."'";
		my $string = "\$$name = $value\;";
		print SHELL "$string\n";

	}	
	elsif ($line =~ /^CODA_legal/) {
		$line =~ s/^CODA_legal\t=\t//;
		$CODA_legal_str .= $line;
	}
	elsif ($line =~ /^DERIV/) {
		$line =~ s/^DERIV\t=\t//;
		$DERIV_str .= $line;
	}
	elsif ($line =~ /^TRC_MORF:/) {
		$line =~ s/^TRC_MORF: //;
		my ($morf, $trc, $msg) = split(/\t+/, $line);
		$morf =~ s/^MORF\(//;
		$morf =~ s/\)$//;
		$trc =~ s/^TRC\(//;
		$trc =~ s/\)$//;
		$msg =~ s/^MSG\(//;
		$msg =~ s/\)$//;
		$string = "\$TRC_MORF{\"$morf\"} = \"$trc--$msg\";";
		print SHELL "$string\n";
	}
	elsif ($line =~ /^RULE:/) {
		my ($pattern, $conditions) = split(/ IFF /, $line);
		$pattern =~ s/([\}\@\*\'])/\\$1/g;	# precede spec chars with backslash
		$pattern =~ s/^RULE: \(/\"/;
		$pattern =~ s/\)$/\"/;
		$conditions =~ s/[\(\)]//g;		# remove parentheses
		if ($conditions =~ / AND /) {
			@conds = split(/ AND /, $conditions);
			$string = "\$IFF_ALL_CONDITIONS{$pattern} = '";
		}
		elsif ($conditions =~ / OR /) {
			@conds = split(/ OR /, $conditions);
			$string = "\$IFF_ONE_CONDITION{$pattern} = '";
		}
		else {
			@conds = $conditions;
			$string = "\$IFF_ALL_CONDITIONS{$pattern} = '";
		}
		foreach $cond (@conds) {$string .= "$cond--";}
		$string =~ s/--$//;
		$string = $string."\';";
		print SHELL "$string\n";
	}
	elsif ($line =~ /^(ERROR|WARNING)/) {
		my ($pattern, $msg) = split (/\t+/, $line);
		$pattern =~ s/^ERROR\(//;
		$pattern =~ s/^WARNING\(//;
		$pattern =~ s/\)$//;
		$msg =~ s/^MSG\(//;
		$msg =~ s/\)$//;
		if ($line =~ /^ERROR/) {$string = "\$ERROR{\"$pattern\"} = $msg;";}
		else {$string = "\$WARNING{\"$pattern\"} = $msg;";}
		print SHELL "$string\n";
	}		
	elsif ($line =~ /^(ONSET|CODA)/) {
		my ($name, $value) = split(/\t=\t/, $line);
		if ($line =~ /(rare|legal)/) {
			$value =~ s/([^\$\|\)\(\_])/\$$1/g;
			$value =~ s/\$\$r\$e\$t\$r\$o\_\$/\$retro_/g;
			$value =~ s/\$\$c\$o\$m\$p\_\$p\$l\$o\$s\$i\$v\$e/\$comp_plosive/g;
			$value =~ s/\$\$c\$o\$m\$p\_\$f\$r\$i\$c\$a\$t\$i\$v\$e/\$comp_fricative/g;
			$value =~ s/\$\$/\$/g;
			$value = "\"($value)\"";
		}
		else {
			$value = "\"($value)\"";
		}
		my $string = "\$$name = $value\;";
		print SHELL "$string\n";
	}
	elsif ($line =~ /^comp\_/) {
		my ($name, $value) = split(/\t+=\t/, $line);
		$value =~ s/\|/.\'\|\'./g;			# replace | with .'|'.
		my $string = "\$$name = $value\;";
		print SHELL "$string\n";
		push (@comp_groups, "\'$name\'");
	}
		
	elsif ($line !~ /^$/ && $line !~ /^\#/) {
		my ($name, $value) = split(/\t+=\t/, $line);
		$value =~ s/\|/.\'\|\'./g;			# replace | with .'|'.
		my $string = "\$$name = $value\;";
		print SHELL "$string\n";
	}
}
# handle the comp feature groups...
$string = "\@comp_groups = (";
foreach $elem (@comp_groups) {$string .= "$elem, ";}
$string =~ s/, $/\)\;/;
print SHELL "$string\n";
# handle the legal codas...
$CODA_legal_str =~ s/([^\^\[\]\$\|\)\(\_])/\$$1/g;
$CODA_legal_str =~ s/\$\$t\$j/\$tj/g;
$CODA_legal_str =~ s/\$\$r\$e\$t\$r\$o_\$l/\$retro_l/g;
$CODA_legal_str =~ s/\$\$r\$e\$t\$r\$o_\$s/\$retro_s/g;
$CODA_legal_str =~ s/\$\$r\$e\$t\$r\$o_\$n/\$retro_n/g;
$CODA_legal_str =~ s/\$\$r\$e\$t\$r\$o_\$t/\$retro_t/g;
$CODA_legal_str =~ s/\$\$r\$e\$t\$r\$o_\$d/\$retro_d/g;
$CODA_legal_str =~ s/\$\$n\$g/\$ng/g;
$CODA_legal_str = "\"($CODA_legal_str)\"";
$CODA_legal_str = "\$CODA_legal = $CODA_legal_str;";
print SHELL "$CODA_legal_str\n";
# handle the derivational substrings...
$DERIV_str = "\'($DERIV_str)\'";
$DERIV_str = "\$DERIV = $DERIV_str;";
print SHELL "$DERIV_str\n";

print SHELL "## END: Values from $rulefile\n";
print SHELL "## ---------------------------------------------------------------------------\n";
close (RULES);


print STDOUT "Setting initial values...\n";
print SHELL "## Initial values:\n";
print SHELL "\$nofLines = 0;\n";
print SHELL "\$nofTrcs = 0;\n";
print SHELL "\$nofErrTrcs = 0;\n";
print SHELL "\$nofGarbage = 0;\n";
print SHELL "\$interval = 500;\n";
print SHELL "\$newInterval = \$interval;\n";
print SHELL "\$correctStart = 0;\n";
print SHELL "\$nofEntriesInSet = 0;\n";
print SHELL "## END: Initial values\n";
print SHELL "## ---------------------------------------------------------------------------\n";

# open the corrPhon-file
open (EXE, "$corrPhon") or die "Can't open $corrPhon for read: $!\n";
print STDOUT "Reading values from $corrPhon...\n";
print SHELL "## Values from $corrPhon:\n";
while (<EXE>) {
	$line = $_;
	print SHELL $line;
}
close (EXE);
print SHELL "## END: Values from $corrPhon\n";
print SHELL "## ---------------------------------------------------------------------------\n";

print STDOUT "Writing to $shell...\n";
print STDOUT "-----------------------------------------------------------\n";
print STDOUT "To check for errors in $infile, run $shell\n";
print STDOUT "-----------------------------------------------------------\n";
close (SHELL);

