#!perl -w

my $dk_kons = "[bcdfghjklmnpqrstvwxz]";

my @dk_ok2el = qw(
r
by
bo
g
ur
is
l
om
ad
ud
p
se
g
ro
te
os
k
ko
s
t
le
ed
ly
ny
sy
s
ry
so
ve
vi
PC
tv
r
eg
af
l
bi
m
ti
d
op
ID
ej
ni
l
cd
ja
ru
to
hu
hi
t
);
my $dk_ok2el = join "|",@dk_ok2el;

my @dk_ok3el = qw(
tid
hus
dag
ls
fri
ret
bog
lov
tur
sag
tal
rd
liv
rum
lb
tj
del
ml
ord
vej
tr
lys
tog
dyr
mad
ln
rig
bil
rr
tag
dr
job
syn
net
sat
ben
bd
sko
par
fag
kd
tab
ln
fly
kb
rs
rd
gr
tro
lag
hal
led
lyd
ost
hr
bad
sal
st
vin
urt
art
bl
fra
rod
dd
mur
syg
fod
hul
kor
nl
bro
ske
fr
hue
leg
dom
sum
hat
rb
uge
sn
sky
fad
avl
vg
nd
kar
mor
uld
bar
gas
dk
eje
gul
mel
kur
sk
sol
fyr
bue
bud
gr
ryg
nd
ovn
pas
bus
ls
top
en
br
orm
sav
ild
vv
kl
ven
hj
sr
nat
kat
lap
lav
akt
far
for
hr
lg
ark
bal
re
rim
dug
arm
kam
sm
lam
kys
hav
je
re
lak
bn
bid
set
rus
lr
hud
klo
pl
tt
sur
abe
lus
sd
gud
god
bod
and
lg
dej
hop
gav
gs
due
lem
pen
bur
lod
db
buk
sti
sd
gal
mos
tyv
rem
rg
hit
st
kr
vis
tov
ind
bf
sl
kom
dal
pil
lg
tap
hyl
bas
pl
kn
hr
hl
egn
gr
hk
tr
mod
sex
tom
roe
fed
til
bor
fil
bed
hen
vd
tip
arv
sne
er
ure
ris
ses
kul
ide
bg
kok
bl
ler
mus
had
id
pol
sl
nb
dyk
kr
kop
ged
lad
dam
reb
ls
fl
hug
dyd
kup
fin
ren
gr
st
rv
lim
nr
lv
rs
dis
kaj
pap
gik
let
ski
ror
hed
dv
sax
ton
ise
vie
eng
sok
nyt
jul
rev
ln
kl
ser
suk
gab
rn
lur
amt
bys
hb
ved
kd
tyr
ve
dok
nar
lok
giv
gys
tot
bd
vel
kid
mr
fj
tue
duo
dyb
kim
tyk
ble
dun
kik
ege
med
bom
veg
ryk
boa
kig
box
myg
mix
gus
vom
rov
nok
hg
fan
ude
bag
mat
vat
ra
rad
rv
kog
soc
sod
rat
dd
kro
dt
nye
sus
br
sl
sov
rd
lyn
kis
sm
lyt
alf
br
pd
hob
ile
fr
vr
fat
gen
fru
bon
mg
mil
fro
vk
alt
urs
bov
mis
aud
rok
gin
rom
kr
kp
gut
haj
ros
has
lig
uro
de
vod
bly
ms
vr
nag
fr
kue
nem
lue
gs
fog
sys
jag
mag
pyt
han
re
gry
jur
lud
gny
bs
tr
jet
kn
fim
peg
tak
ask
jav
fem
byg
bug
agt
vid
red
neg
dat
ion
lab
ynk
per
pub
ing
ane
ld
tuf
puf
way
ts
tud
db
sut
som
hov
vet
adm
ung
aks
viv
hos
vor
pak
tis
);
my $dk_ok3el = join "|",@dk_ok3el;

my @dk_ok2fl = qw(
);
my $dk_ok2fl = join "|",@dk_ok2fl;

my @dk_ok3fl = qw(

);
my $dk_ok3fl = join "|",@dk_ok3fl;

my @dk_no_prepend_s = qw/
ad
ag
ar
as
av
ba
be
bi
bo
br
b
b
b
ch
da
de
di
dr
d
d
ef
en
fa
fi
fl
fo
fr
fu
gr
g
g
hi
hj
hu
hv
h
h
ja
jo
ju
kl
kn
kv
mo
n
op
ps
ra
re
ri
ry
r
sa
sc
sf
sh
si
sk
sl
sm
sn
sp
st
sv
sy
s
tj
ud
vo
yd
b
g
n
j
k
v
/;
my $dk_no_prepend_s = join "|",@dk_no_prepend_s;

my @dk_prepend_s = qw/
au
ca
ci
cu
he
ik
im
ky
k
la
me
mi
mu
my
m
m
na
ne
no
n
oc
og
ok
ol
on
ov
p
p
vu
v
yg
ys

l
n
s

/;
my $dk_prepend_s = join "|",@dk_prepend_s;

my @dk_dont_know_s = qw/
/;
my $dk_dont_know_s = join "|",@dk_dont_know_s;



sub postfix {
	my $dec = shift;
	$dec = fix_dec_el($dec);
	$dec = fix_fl_1_char($dec);
	$dec = fix_ml_seq($dec);
	$dec = fix_dec_fl($dec);
	
#	$dec = fix_fl_2_char($dec);
#	$dec = fix_fl_3_char($dec);
#	$dec = fix_ml_2_char($dec);
#	$dec = fix_fl_2_char($dec);
	
	return $dec;
}


sub fix_dec_el {
	my $dec = shift;

	# remove trailing separators
	$dec =~ s/\++$//;

	# fix one-letter el. Only accept 'i' and ''. Remove leading boundarie mark(s) in other cases
	$dec =~ s/\++([^i])$/$1/;

	
	# fix two-letter el. First, do not accept consonant sequences. (This is no longer nescessary...)
#	$dec =~ s/\++($dk_kons+)$/$1/;

	# Only accept listed 2-letter endings from @dk_ok2el
	$dec =~ s/\++(..)$/$1/ if $dec !~ /\+($dk_ok2el)$/;
	
	# fix three-letter el. Only accept listed 3-letter endings from @dk_ok3el
	$dec =~ s/\++(...)$/$1/ if $dec !~ /\+($dk_ok3el)$/;

	return $dec;	
}

sub fix_dec_fl {
	my $dec = shift;
	
	# 'fix' linking s. Many will still be appended incorrectly. Snyft...
#	$dec =~ s/(s\+s)\+([^s])/$1$2/g;
#	$dec =~ s/([^s])\+(s\+s)/$1$2/g;
#	$dec =~ s/\+s\+/s\+/g;
	
	# some following patterns indicate s belongs to fl
	$dec =~ s/\+(s\+)($dk_no_prepend_s)/$1$2/g;
	
	# some following patterns indicate s belongs to el
	$dec =~ s/(\+s)\+($dk_prepend_s)/$1$2/g;
	
	
	return $dec;
}

sub fix_fl_1_char {
	my $dec = shift;
	# 1-letter fl. Only accept i  
	$dec =~ s/^([^i])\+/$1/g;
	return $dec;
}

sub fix_fl_2_char {
	my $dec = shift;

	# Only accept listed 2-letter fl from @dk_ok2fl
	$dec =~ s/^(..)\++/$1/ if $dec !~ /^($dk_ok2fl)\+/;
#	print "$dec\n$dec-\-\>";

	return $dec;
}

sub fix_fl_3_char {
	my $dec = shift;

	# Only accept listed 3-letter fl from @dk_ok3fl
	$dec =~ s/^(...)\++/$1/ if $dec !~ /^($dk_ok3fl)\+/;
#	print "$dec\n$dec-\-\>";

	return $dec;
}

sub fix_ml_seq {
	my $dec = shift;
	# some patterns found for 1-letter sequences
	$dec =~ s/\+a\+f\+/\+af/g;
	$dec =~ s/\+t\+s\+/ts\+/g;
	$dec =~ s/\+s\+m\+/s\+m/g;
	$dec =~ s/\+r\+\+/r\+/g;
	$dec =~ s/\+a\+n\+/\+an/g;
	$dec =~ s/\+s\+t\+/st\+/g;
	$dec =~ s/\+s\+i\+/\+si/g;
	$dec =~ s/\+f\+n\+/\+fn/g;
	$dec =~ s/\+a\+f\+/\+af/g;
	$dec =~ s/\+s\+k\+/sk\+/g;
	$dec =~ s/\+u\+d\+/\+ud/g;
	$dec =~ s/\+r\+i\+/r\+i/g;
	$dec =~ s/\+s\+e\+/\+se/g;
	$dec =~ s/\+i\+n\+/in/g;
	return $dec;
}
sub fix_ml_2_char {
	my $dec = shift;

	# -be- and -re- -de- always collapsed with el. -me- -se- most often
	$dec =~ s/(\+[mrbds]e)\+/$1/g;

	# -by-
	$dec =~ s/(\+by)\+((r|gg|gd|s)[^d])/$1$2/g;

	# -te- with fl most often (5 of 7 times)
	$dec =~ s/\+([t]e\+)/$1/g;

	# -in- with el most often (not tein/rein/otin)
	$dec =~ s/(te|re|ot)\+(in\+)/$1$2/g;
	$dec =~ s/(\+[ia]n)\+/$1/g;
	
	# -av- to el
	$dec =~ s/(\+av)\+/$1/g;

	# -ve- to fl. some exceptions
	$dec =~ s/(\+ve)\+(sen|ske|ving|str)/$1$2/g;
	$dec =~ s/\+(ve\+)/$1/g;

	return $dec;
}

1;


__END__



s	1424	169	8
r	218	18
e	157	18
t	122	10
l	102	16
g	73
n	70	10
k	65
f	36
o	35
v	29
m	28
d	20
a	14
p	10
i	9
	4
	1
b	1
h	1




s	169
r	18
e	18
l	16
t	10
n	10
k	9
v	5
g	4
a	2
h	1
	1
d	1
m	1
f	1
o	1



s	8





2ml:

<se	64
<in	64
<an	55
<av	52
<ve	49
ar	49
fe	49
le	45
al	37
st	37
n	34
ut	32
pe	30
om	24
ge	23
l	23
ne	22
er	21
ka	19
s	18
gg	17
ad	16
is	16
r	15
el	12
lo	12
ko	11
ce	10
p	8
r	7
he	7
ke	7
ti	7
at	7
en	6
b	6
la	6
ur	6
bo	6
us	6
lm	5
ri	5
h	5
au	5
im	5
em	5
ds	4
bl	4
mi	4
pa	4
r	4
ga	4
m	4
un	4
ul	4
fa	3
ok	3
on	3
p	3
ps	3
fn	3
n	3
ol	3
vi	3
ba	3
sk	3
di	3
m	2
ra	2
br	2
as	2
bu	2
ro	2
gi	2
kn	2
ma	2
or	2
ig	2
os	2
ha	2
t	2
ue	2
ht	2
ye	2
vy	1
ie	1
ru	1
if	1
rn	1
f	1
ta	1
nk	1
r	1
va	1
ni	1
fi	1
pi	1
je	1
d	1
da	1
dy	1
sn	1
ls	1
s	1
pr	1
so	1
kk	1
sa	1
ts	1
it	1
id	1
iv	1


OK 3ml i facit

rs	146
hus	105
dyr	58
bok	41
bil	39
rd	25
fot	22
cup	21
lov	21
fly	18
bt	18
fag	17
br	17
ord	16
hy	16
hg	15
mor	11
tog	10
tre	10
vei	9
mat	7
lk	6
dom	5
st	5
del	5
fri	5
rot	5
tur	5
mai	4
rr	4
lys	4
inn	4
kl	4
fr	3
kol	3
ski	3
sak	3
dag	3
sj	3
ned	3
sn	3
veg	3
tal	2
sau	2
ark	2
ty	2
not	2
hiv	2
far	2
kor	2
sko	2
fr	2
sol	2
lv	2
mel	2
ye	2
kar	2
arm	2
ved	2
bit	1
hav	1
nr	1
ovn	1
jet	1
bar	1
vr	1
re	1
opp	1
sm	1
var	1
gs	1
seg	1
sal	1
amt	1
god	1
re	1
lus	1
bad	1
ost	1
bue	1
bak	1
orm	1
